exec("./allGameScripts-Vanilla.cs");

//global variables that exist in v21 but not in v20
//only for v21 addons to read values from, of course changing these wont do anything
$Server::BrickRespawnTime = $Pref::Server::BrickRespawnTime;
$Server::ClearEventsOnClientExit = $Pref::Server::ClearEventsOnClientExit;
$Server::MaxBricksPerSecond = $Pref::Server::MaxBricksPerSecond;
$Server::MaxPhysVehicles_Total = $Pref::Server::MaxPhysVehicles_Total;
$Server::MaxPlayerVehicles_Total = $Pref::Server::MaxPlayerVehicles_Total;
$Server::Name = $Pref::Server::Name;
$Server::Quota::Environment = $Pref::Server::Quota::Environment;
$Server::Quota::Item = $Pref::Server::Quota::Item;
$Server::Quota::Misc = $Pref::Server::Quota::Misc;
$Server::Quota::Player = $Pref::Server::Quota::Player;
$Server::Quota::Projectile = $Pref::Server::Quota::Projectile;
$Server::Quota::Schedules = $Pref::Server::Quota::Schedules;
$Server::Quota::Vehicle = $Pref::Server::Quota::Vehicle;
$Server::QuotaLAN::Environment = $Pref::Server::QuotaLAN::Environment;
$Server::QuotaLAN::Item = $Pref::Server::QuotaLAN::Item;
$Server::QuotaLAN::Misc = $Pref::Server::QuotaLAN::Misc;
$Server::QuotaLAN::Player = $Pref::Server::QuotaLAN::Player;
$Server::QuotaLAN::Projectile = $Pref::Server::QuotaLAN::Projectile;
$Server::QuotaLAN::Schedules = $Pref::Server::QuotaLAN::Schedules;
$Server::QuotaLAN::Vehicle = $Pref::Server::QuotaLAN::Vehicle;
$Server::WelcomeMessage = $Pref::Server::WelcomeMessage;
$Server::WrenchEventsAdminOnly = $Pref::Server::WrenchEventsAdminOnly;

//these sounds were made default in v21
datablock AudioProfile (fastImpactSound)
{
	fileName = "base/data/sound/fastimpact.WAV";
	description = AudioDefault3d;
	preload = 1;
};
datablock AudioProfile (slowImpactSound)
{
	fileName = "base/data/sound/slowimpact.wav";
	description = AudioDefault3d;
	preload = 1;
};

///////////////////////////////////////////
//B4v21 Custom Master Server and Auth Fix//
///////////////////////////////////////////

if ($Pref::MasterServer $= "")
    $Pref::MasterServer = "b4v21.block.land:80";

package enableCustomMS
{
	function postServerTCPObj::connect(%this, %addr)
	{
		%oldLen   = strLen(getField(%this.cmd, getFieldCount(%this.cmd) - 1)) - 1;
		%this.cmd = strReplace(%this.cmd, "&Port=" @ mFloor($Server::Port), "&Port=" @ mFloor($Server::Port) @ "&Patch=1&ourName=" @ urlEnc($Pref::Player::NetName) @ "&GamePatch=" @ urlEnc(getCompileTimeString()));
		%newLen   = strLen(getField(%this.cmd, getFieldCount(%this.cmd) - 1)) - 1;
		%this.cmd = strReplace(%this.cmd, "Content-Length: " @ %oldLen, "Content-Length: " @ %newLen);
        	%this.cmd = strReplace(%this.cmd, "master2.blockland.us", $Pref::MasterServer);
		Parent::connect(%this, $Pref::MasterServer);
	}

	function queryMasterTCPObj::connect(%this, %addr)
	{
		%this.cmd = strReplace(%this.cmd, "master2.blockland.us", $Pref::MasterServer);
		Parent::connect(%this, $Pref::MasterServer);
	}
};

package B4v21AuthServer
{
	function authTCPObj_Client::connect(%this, %url)
	{
		%url      = strReplace(%url, "auth.blockland.us", "b4v21.block.land");
		%this.cmd = setword(%this.cmd, 1, (strPos(%this.cmd, "authInit") != -1 ? "/api/authInit.php" : "/api/authConfirm2.php"));
		%this.cmd = strReplace(%this.cmd, "auth.blockland.us", "b4v21.block.land");
		Parent::connect(%this, %url);
	}
	function authTCPObj_Client::onLine(%this, %line)
	{
		switch$(firstWord(%line))
		{
			case "NOTE":
				%line = removeWord(%line, 0);
				
				if (!isObject(Canvas))
					echo("NOTE: " @ %line);
				else
					messageBoxOk("Authentication Server Notice", %line);
				
			default:
				Parent::onLine(%this, %line);
		}
	}
	function authTCPObj_Server::connect(%this, %url)
	{
		%url      = strReplace(%url, "auth.blockland.us", "b4v21.block.land");
		%this.cmd = setWord(%this.cmd, 1, (strPos(%this.cmd, "authInit") != -1 ? "/api/authInit.php" : "/api/authConfirm2.php"));
		%this.cmd = strReplace(%this.cmd, "auth.blockland.us", "b4v21.block.land");
		Parent::connect(%this, %url);
	}
	function servAuthTCPobj::connect(%this, %url)
	{
		%url      = strReplace(%url, "auth.blockland.us", "b4v21.block.land");
		%this.cmd = setWord(%this.cmd, 1, "/api/authQuery.php");
		%this.cmd = strReplace(%this.cmd, "auth.blockland.us", "b4v21.block.land");
		Parent::connect(%this, %url);
	}
};

package B4v21OnlyServerPackage
{
	function GameConnection::onClientEnterGame(%this)
	{
		Parent::onClientEnterGame(%this);
		
		// Get our brick group.
		%ourBrickGroup = %this.brickGroup;
		
		// Make sure it exists...
		if (!isObject(%ourBrickGroup))
		{
			announce("ERROR: ::onClientEnterGame() - " @ %this.getPlayerName() @ " has no brick group!");
			return;
		}
		
		// Add potential trust links
		for (%i = 0; %i < %this.potentialTrustCount; %i++)
		{
			%trustInfo   = %this.potentialTrust[%i];
			%targetBL_ID = getField(%trustInfo, 0);
			%trustLevel  = getField(%trustInfo, 1);
			
			if (!isObject("BrickGroup_" @ %targetBL_ID))
			{
				%SO        = new SimGroup("BrickGroup_" @ %targetBL_ID);
				%SO.client = 0;
				%SO.name   = "\c1BL_ID: " @ %targetBL_ID @ "\c1\c0";
				%SO.bl_id  = %targetBL_ID;
				mainBrickGroup.add(%SO);
			}
			
			if (%trustLevel != 0)
			{
				("BrickGroup_" @ %targetBL_ID).addPotentialTrust(%this.getBLID(), %trustLevel);
			}
		}
		
		// Setup trust links
		serverCmdTrustListUpload_Done(%this);
	}
	function servAuthTCPobj::onConnected(%this)
	{
		%postText   = "NAME=" @ urlEnc(%this.client.getPlayerName());
		if (strPos(%this.cmd, "IP=") != -1)
		{
			%postText = %postText @ "&IP=" @ %this.client.getRawIP();
		}
		
		%postText   = %postText @ "&FA=" @ (%this.client.getHasAuthedOnce() ? "0" : "1");
		%postTexLen = strlen(%postText);
		%this.cmd   = "POST /api/authQuery.php HTTP/1.0\r\nHost: b4v21.block.land\r\nContent-Type: application/x-www-form-urlencoded\r\nContent-Length: " @ %postTexLen @ "\r\n\r\n" @ %postText @ "\r\n";
		
		if (!%this.client.getHasAuthedOnce())
			%this.client.potentialTrustCount = 0;
		
		Parent::onConnected(%this);
	}
	function servAuthTCPobj::onLine(%this, %line)
	{
		%word = getWord(%line, 0);
		
		if (%word $= "TRUST" && !%this.client.getHasAuthedOnce())
		{
			if (isObject(%this.client))
			{
				// Add it to this client's potential trust list
				%this.client.potentialTrust[%this.client.potentialTrustCount] = getWord(%line, 1) TAB getTrustIndexByName(getWord(%line, 2));
				
				// Increment the count
				%this.client.potentialTrustCount++;
			}
			else 
			{
				error("ERROR: servAuthTCPobj::onLine() - Orphan tcp object ", %this);
			}
			
			return;
		}
		
		Parent::onLine(%this, %line);
	}
	// 5:31 PM 4/3/2023 - Sanitize Welcome Message
	function sendLoadInfoToClient(%client)
	{
		Parent::sendLoadInfoToClient(%client);
		$Pref::Server::WelcomeMessage = strReplace($Pref::Server::WelcomeMessage, "\\", "/");
		$Pref::Server::WelcomeMessage = strReplace($Pref::Server::WelcomeMessage, "'", "\"");
		$Pref::Server::WelcomeMessage = strReplace($Pref::Server::WelcomeMessage, "/c", "\\" @ "c");
	}
};

if ($Server::Dedicated)
{
	activatePackage(enableCustomMS);
	activatepackage(B4v21AuthServer);
}

activatePackage(B4v21OnlyServerPackage);

//addon list code to add support for changing the autoenable addons pref
function updateAddOnList ()
{
	echo ("\n--------- Updating Add-On List ---------");
	deleteVariables ("$AddOn__*");
	if (isFile ("config/server/ADD_ON_LIST.cs"))
	{
		exec ("config/server/ADD_ON_LIST.cs");
	}
	else 
	{
		exec ("base/server/defaultAddOnList.cs");
	}
	if (isFile ("base/server/crapOns_Cache.cs"))
	{
		exec ("base/server/crapOns_Cache.cs");
	}
	%dir = "Add-Ons/*/server.cs";
	%fileCount = getFileCount (%dir);
	%filename = findFirstFile (%dir);
	%i = 0;
	while (%i < %fileCount)
	{
		%path = filePath (%filename);
		%dirName = getSubStr (%path, strlen ("Add-Ons/"), strlen (%path) - strlen ("Add-Ons/"));
		%varName = getSafeVariableName (%dirName);
		echo ("Checking Add-On " @ %dirName);
		if (!isValidAddOn (%dirName, 1))
		{
			deleteVariables ("$AddOn__" @ %varName);
			%filename = findNextFile (%dir);
		}
		else 
		{
			if ($Server::Dedicated)
			{
				if ($pref::AutoEnableAddOns == 1 && ($AddOn__[%varName] $= "" || $AddOn__[%varName] == 0))
				{
					$AddOn__[%varName] = 1;
				}
				else if (mFloor ($AddOn__[%varName]) <= 0)
				{
					$AddOn__[%varName] = -1;
				}
				else 
				{
					$AddOn__[%varName] = 1;
				}
			}
			else if ($pref::AutoEnableAddOns == 1 && $AddOn__[%varName] $= "") 
			{ 
				$AddOn__[%varName] = 1;
			}
			else if (mFloor ($AddOn__[%varName]) <= 0)
			{
				$AddOn__[%varName] = -1;
			}
			else 
			{
				$AddOn__[%varName] = 1;
			}
			%filename = findNextFile (%dir);
		}
		%i += 1;
	}
	echo ("");
	export ("$AddOn__*", "config/server/ADD_ON_LIST.cs");
}

//v3.15, adding an echo line to this to be able to tell which music loop is crashing. also removing deleting stereo music. also added a chat message when loops are over 1mb.
function createMusicDatablocks ()
{
	updateMusicList ();
	%dir = "Add-ons/Music/*.ogg";
	%fileCount = getFileCount (%dir);
	%filename = findFirstFile (%dir);
	%i = 0;
	while (%i < %fileCount)
	{
		%base = fileBase (%filename);
		%uiName = strreplace (%base, "_", " ");
		%varName = getSafeVariableName (%base);
		if (!$Server::Dedicated)
		{
			if (getRealTime () - $lastProgressBarTime > 200)
			{
				LoadingProgress.setValue (%i / %fileCount);
				$lastProgressBarTime = getRealTime ();
				Canvas.repaint ();
			}
		}
		if (!isValidMusicFilename (%filename))
		{
			%filename = findNextFile (%dir);
		}
		else if (getFileLength (%filename) > 1048576)
		{
			error ("ERROR: Music file \"" @ %filename @ "\" > 1mb - removing");
			schedule (1000, 0, MessageAll, '', "ERROR: Music file \"" @ %filename @ "\" is over 1mb - removing");
			%filename = findNextFile (%dir);
		}
		else 
		{
			if ($Music__[%varName] $= 1)
			{
				%dbName = "musicData_" @ %varName;
				echo("creating music loop "@%varName);
				%command = "datablock AudioProfile(" @ %dbName @ ") {" @ "filename = \"" @ %filename @ "\";" @ "description = AudioMusicLooping3d;" @ "preload = true;" @ "uiName = \"" @ %uiName @ "\";" @ "};";
				eval (%command);
				if (%dbName.isStereo ())
				{
					error ("ERROR: Stereo sound detected on \"" @ %dbName.getName () @ "\" - Removing datablock.");
					schedule (1000, 0, MessageAll, '', "Stereo sound detected on  \"" @ fileName (%dbName.fileName) @ "\" - Removing datablock.");
					%dbName.uiName = "";
					%dbName.delete ();
				}
			}
			%filename = findNextFile (%dir);
		}
		%i += 1;
	}
}

//v3.16 - adding this function from v21's Support_PlayerPersistence to the base game, im not sure why badspot didnt do this himself instead of splitting that addon into two
//also, why was it in its own package?
function RegisterPersistenceVar(%name, %matchAll, %matchDataBlock)
{
	if(%matchAll)
	{
		//we need these in a list
		$Persistence::MatchAll_Count = mFloor($Persistence::MatchAll_Count);
		
		//see if it is already registered;
		for(%i = 0; %i < $Persistence::MatchAll_Count; %i++)
		{
		if($Persistence::MatchAll_Entry[%i] $= %name)
			return;
		}

		//not registered yet, add it
		$Persistence::MatchAll_Entry[$Persistence::MatchAll_Count] = %name;
		$Persistence::MatchAll_Count++;
	}
	else
	{
		//simple name match
		$Persistence::MatchName[%name] = true;
		$Persistence::MatchDatablock[%name] = %matchDataBlock;
	}      
}

//for some reason if you disable emote_alarm this servercmd still exists on the server, but is missing the AlarmProjectile so it errors in console. wtf
function servercmdalarm(%c) {}


//Script_ClearSpam merged into base game
function serverCmdClearSpamBricks(%client)
{
   if(!%client.isAdmin)
      return;
   
   if($Server::BrickCount > 0)
		messageAll('MsgClearBricks', "\c3" @ %client.getPlayerName() @ "\c0 cleared spam bricks.");

   //loop through all bricks
   %groupCount = MainBrickGroup.getCount();
   for(%i = 0; %i < %groupCount; %i++)
   {
      %group = MainBrickGroup.getObject(%i);
      %count = %group.getCount();
      for(%j = 0; %j < %count; %j++)
      {
         %brick = %group.getObject(%j);

         //we're only interested in bricks...
         if(!(%brick.getType() & $TypeMasks::FxBrickAlwaysObjectType))
            continue;

         //that are on the ground...
         if(%brick.getDistanceFromGround() != 0)
            continue;

         //and planted...
         if(!%brick.isPlanted)
            continue;
         
         //and not dead...
         if(%brick.isDead)
            continue;

         %brickData = %brick.getDataBlock().getID();
         if(%brickData.category $= "Baseplates")
         {
            //it's a baseplate, but if it's all alone and red or has an item attached to it, it's probably still spam
            if(%brick.getNumUpBricks() == 0 && (%brick.getColorID() == 0 || isObject(%brick.item)) )
            {
               %brick.killBrick();
            }
            //if this is a red "plain" or "road" baseplate with an identical baseplate on top of it, it's probably spam
            else if(%brick.getNumUpBricks() == 1 && %brick.getColorID() == 0 && (%brickData.subCategory $= "Plain" || %brickData.subCategory $= "Road"))
            {
               %upBrick = %brick.getUpBrick(0);
               if(%upBrick.getDataBlock().getID() == %brickData && %upBrick.getColorID() == 0)
                  %brick.killBrick();
            }
         }
         else
         {
            //not a baseplate, kill it
            %brick.killBrick();
         }
      }
   }
}

function serverCmdClearFloatingBricks(%client)
{
   if(!%client.isAdmin)
      return;
   
   if($Server::BrickCount > 0)
		messageAll('MsgClearBricks', "\c3" @ %client.getPlayerName() @ "\c0 cleared floating bricks.");

   //loop through all bricks
   %groupCount = MainBrickGroup.getCount();
   for(%i = 0; %i < %groupCount; %i++)
   {
      %group = MainBrickGroup.getObject(%i);
      %count = %group.getCount();
      for(%j = 0; %j < %count; %j++)
      {
         %brick = %group.getObject(%j);
         if(!(%brick.getType() & $TypeMasks::FxBrickAlwaysObjectType))
            continue;

         if(%brick.getDistanceFromGround() != 2147483647)
            continue;

         if(!%brick.isPlanted)
            continue;
         
         if(%brick.isDead)
            continue;

         %brick.killBrick();
      }
   }
}

function serverCmdClearFarAwayBricks(%client)
{
   if(!%client.isAdmin)
      return;

   %player = %client.player;

   if(!isObject(%player))
      return;

   if($Server::BrickCount <= 0)
      return;

   messageAll('MsgClearBricks', "\c3" @ %client.getPlayerName() @ "\c0 cleared far away bricks.");

   %playerPos = %player.getPosition();

   //loop through all bricks
   %groupCount = MainBrickGroup.getCount();
   for(%i = 0; %i < %groupCount; %i++)
   {
      %group = MainBrickGroup.getObject(%i);
      %count = %group.getCount();
      for(%j = 0; %j < %count; %j++)
      {
         %brick = %group.getObject(%j);
         if(!(%brick.getType() & $TypeMasks::FxBrickAlwaysObjectType))
            continue;

         if(%brick.getDistanceFromGround() != 0)
            continue;

         if(!%brick.isPlanted)
            continue;
         
         if(%brick.isDead)
            continue;

         %brickPos = %brick.getPosition();

         %delta = vectorSub(%brickPos, %playerPos);
         %distance = vectorLen(%delta);

         if(%distance < 1000)
            continue;

         %brick.killBrick();
      }
   }
}


//
//various v21 versions of functions added in v3.15 to allow bot holes to work properly:
//

//fixes being able to kill bots with vehicles
function miniGameCanDamage (%client, %victimObject)
{
	%miniGame1 = getMiniGameFromObject (%client);
	%miniGame2 = getMiniGameFromObject (%victimObject);
	if (%client.isBot)
	{
		if (isObject (%client.spawnBrick))
		{
			%minigameHost1 = %miniGame1.owner;
			%isHost1 = %client.spawnBrick.getGroup ().client == %minigameHost1;
			%isIncluded1 = %miniGame1.UseAllPlayersBricks;
			%botNum1 = 1;
			%botCount += 1;
		}
		else 
		{
			%otherBotCount += 1;
		}
	}
	if (%victimObject.isBot)
	{
		if (isObject (%victimObject.spawnBrick))
		{
			%minigameHost2 = %miniGame2.owner;
			%isHost2 = %victimObject.spawnBrick.getGroup ().client == %minigameHost2;
			%isIncluded2 = %miniGame2.UseAllPlayersBricks;
			%botNum2 = 1;
			%botCount += 1;
		}
		else 
		{
			%otherBotCount += 1;
		}
	}
	%type = %victimObject.getType ();
	if (%miniGame2 != %miniGame1 && getBL_IDFromObject (%client) == getBL_IDFromObject (%victimObject))
	{
		%doHack = 1;
		if (%victimObject.getType () & $TypeMasks::PlayerObjectType)
		{
			if (%victimObject.getControllingClient () > 0)
			{
				%doHack = 0;
			}
		}
		if (%doHack)
		{
			%miniGame2 = %miniGame1;
		}
	}
	if ($Server::LAN)
	{
		if (!isObject (%miniGame1))
		{
			return 1;
		}
		if (%type & $TypeMasks::PlayerObjectType)
		{
			if (%victimObject.isBot || %client.isBot)
			{
				if (%miniGame1 != %miniGame2)
				{
					return 0;
				}
				if (%botCount == 2)
				{
					if ((%isHost1 && %isHost2) || %isIncluded1 || %isIncluded2)
					{
						return 1;
					}
					else 
					{
						return 0;
					}
				}
				if (%miniGame1.BotDamage)
				{
					%cIsPlayerVehicle = %client.getClassName () $= "AIPlayer" && !%client.isBot;
					if (%cIsPlayerVehicle && !%miniGame1.VehicleDamage)
					{
						return 0;
					}
					if (%otherBotCount)
					{
						return 1;
					}
					if (%botCount == 2)
					{
						if ((%isHost1 && %isHost2) || %isIncluded1 || %isIncluded2)
						{
							return 1;
						}
						else 
						{
							return 0;
						}
					}
					if (%botNum1)
					{
						%a = 1;
						if (%isHost[%a] || %isIncluded[%a])
						{
							return 1;
						}
						else 
						{
							return 0;
						}
					}
					if (%botNum2)
					{
						%a = 2;
						if (%isHost[%a] || %isIncluded[%a])
						{
							return 1;
						}
						else 
						{
							return 0;
						}
					}
					return 1;
				}
				else 
				{
					return 0;
				}
			}
			else if (isObject (%victimObject.client))
			{
				if (%miniGame1 != %miniGame2)
				{
					return 0;
				}
				if (%miniGame1.WeaponDamage)
				{
					return 1;
				}
			}
			else if (%miniGame1.VehicleDamage)
			{
				return 1;
			}
		}
		else if (%type & $TypeMasks::VehicleObjectType)
		{
			if (%miniGame1.VehicleDamage)
			{
				return 1;
			}
		}
		else if (%type & $TypeMasks::FxBrickAlwaysObjectType)
		{
			if (%miniGame1.BrickDamage)
			{
				return 1;
			}
		}
		else if (%miniGame1.WeaponDamage)
		{
			return 1;
		}
		return 0;
	}
	if (!isObject (%miniGame1) && !isObject (%miniGame2))
	{
		return -1;
	}
	if (%miniGame1 != %miniGame2)
	{
		return 0;
	}
	if (!isObject (%miniGame1))
	{
		return 0;
	}
	%ruleDamage = 0;
	if (%type & $TypeMasks::PlayerObjectType)
	{
		if (%victimObject.isBot || %client.isBot)
		{
			if (%botCount == 2)
			{
				if ((%isHost1 && %isHost2) || %isIncluded1 || %isIncluded2)
				{
					return 1;
				}
				else 
				{
					return 0;
				}
			}
			if (%miniGame1.BotDamage)
			{
				%cIsPlayerVehicle = %client.getClassName () $= "AIPlayer" && !%client.isBot;
				if (%cIsPlayerVehicle && !%miniGame1.VehicleDamage)
				{
					return 0;
				}
				if (%otherBotCount)
				{
					return 1;
				}
				if (%botCount == 2)
				{
					if ((%isHost1 && %isHost2) || %isIncluded1 || %isIncluded2)
					{
						return 1;
					}
					else 
					{
						return 0;
					}
				}
				if (%botNum1)
				{
					%a = 1;
					if (%isHost[%a] || %isIncluded[%a])
					{
						return 1;
					}
					else 
					{
						return 0;
					}
				}
				if (%botNum2)
				{
					%a = 2;
					if (%isHost[%a] || %isIncluded[%a])
					{
						return 1;
					}
					else 
					{
						return 0;
					}
				}
				return 1;
			}
			else 
			{
				return 0;
			}
		}
		else if (isObject (%victimObject.client))
		{
			if (%miniGame1.WeaponDamage)
			{
				if (%victimObject.client == %client)
				{
					if (%miniGame1.SelfDamage)
					{
						return 1;
					}
					else 
					{
						return 0;
					}
				}
				else 
				{
					return 1;
				}
			}
			else 
			{
				return 0;
			}
		}
		else if (%miniGame1.VehicleDamage)
		{
			%ruleDamage = 1;
		}
	}
	else if (%type & $TypeMasks::VehicleObjectType)
	{
		if (%miniGame1.VehicleDamage)
		{
			%ruleDamage = 1;
		}
	}
	else if (%type & $TypeMasks::FxBrickAlwaysObjectType)
	{
		if (%miniGame1.BrickDamage)
		{
			%ruleDamage = 1;
		}
	}
	else if (%miniGame1.WeaponDamage)
	{
		%ruleDamage = 1;
	}
	if (%ruleDamage == 0)
	{
		return 0;
	}
	if (%miniGame1.UseAllPlayersBricks)
	{
		return 1;
	}
	else 
	{
		%victimBL_ID = getBL_IDFromObject (%victimObject);
		if (%victimBL_ID == %miniGame1.owner.getBLID ())
		{
			return 1;
		}
	}
	return 0;
}

function getMiniGameFromObject (%obj)
{
	if (!isObject (%obj))
	{
		return -1;
	}
	%miniGame = -1;
	if (isObject (%obj.miniGame))
	{
		return %obj.miniGame;
	}
	if (%obj.getClassName () $= "ScriptObject")
	{
		if (%obj.class $= "MiniGameSO")
		{
			%miniGame = %obj;
		}
		else 
		{
			%miniGame = -1;
		}
	}
	else if (%obj.getClassName () $= "GameConnection")
	{
		%miniGame = %obj.miniGame;
	}
	else if ((%obj.getType () & $TypeMasks::PlayerObjectType) || (%obj.getType () & $TypeMasks::CorpseObjectType))
	{
		if (isObject (%obj.client))
		{
			%miniGame = %obj.client.miniGame;
		}
		else if ($Server::LAN)
		{
			if (isObject (%obj.spawnBrick))
			{
				if (isObject (%obj.spawnBrick.client))
				{
					%miniGame = %obj.spawnBrick.client.miniGame;
				}
			}
		}
		else if (isObject (%obj.spawnBrick))
		{
			if (isObject (%obj.spawnBrick.getGroup ().getClient ()))
			{
				%miniGame = %obj.spawnBrick.getGroup ().getClient ().miniGame;
			}
		}
	}
	else if (%obj.getType () & $TypeMasks::ItemObjectType)
	{
		if ($Server::LAN)
		{
			return -1;
			if (isObject (%obj.spawnBrick))
			{
				if (isObject (%obj.spawnBrick.client))
				{
					%miniGame = %obj.spawnBrick.client.miniGame;
				}
			}
		}
		else if (isObject (%obj.spawnBrick))
		{
			if (isObject (%obj.spawnBrick.getGroup ().getClient ()))
			{
				%miniGame = %obj.spawnBrick.getGroup ().getClient ().miniGame;
			}
		}
		else 
		{
			%miniGame = %obj.miniGame;
		}
	}
	else if (%obj.getType () & $TypeMasks::FxBrickAlwaysObjectType)
	{
		if ($Server::LAN)
		{
			%clientCount = ClientGroup.getCount ();
			%i = 0;
			while (%i < %clientCount)
			{
				%cl = ClientGroup.getObject (%i);
				if (isObject (%cl.miniGame))
				{
					%miniGame = %cl.miniGame;
					break;
				}
				%i += 1;
			}
		}
		else if (isObject (%obj.getGroup ().getClient ()))
		{
			%miniGame = %obj.getGroup ().getClient ().miniGame;
		}
	}
	else if (%obj.getType () & $TypeMasks::VehicleObjectType)
	{
		if ($Server::LAN)
		{
			return -1;
			if (isObject (%obj.spawnBrick))
			{
				if (isObject (%obj.spawnBrick.client))
				{
					%miniGame = %obj.spawnBrick.client.miniGame;
				}
			}
		}
		else if (isObject (%obj.spawnBrick))
		{
			if (isObject (%obj.spawnBrick.getGroup ().getClient ()))
			{
				%miniGame = %obj.spawnBrick.getGroup ().getClient ().miniGame;
			}
		}
	}
	else if (%obj.getType () & $TypeMasks::ProjectileObjectType)
	{
		if (isObject (%obj.client))
		{
			%miniGame = %obj.client.miniGame;
		}
	}
	else 
	{
		if (!isObject (%miniGame))
		{
			if (isObject (%obj.miniGame))
			{
				%miniGame = %obj.miniGame;
			}
		}
		if (!$Server::LAN)
		{
			if (!isObject (%miniGame))
			{
				if (isObject (%obj.spawnBrick))
				{
					if (isObject (%obj.spawnBrick.getGroup ().getClient ()))
					{
						%miniGame = %obj.spawnBrick.getGroup ().getClient ().miniGame;
					}
				}
			}
		}
		if (!isObject (%miniGame))
		{
			if (isObject (%obj.client))
			{
				%miniGame = %obj.client.miniGame;
			}
		}
	}
	%blid = getBL_IDFromObject (%obj);
	if (%blid == 888888)
	{
		if (isObject ($DefaultMiniGame))
		{
			%miniGame = $DefaultMiniGame;
		}
	}
	if (!isObject (%miniGame))
	{
		if (isObject ($DefaultMiniGame))
		{
			%miniGame = $DefaultMiniGame;
		}
	}
	if (!isObject (%miniGame))
	{
		%miniGame = -1;
	}
	return %miniGame;
}

//fixes bots being able to trigger onbottouch events
function fxDTSBrickData::onPlayerTouch (%data, %obj, %player)
{
	if (getSimTime () - %player.spawnTime < $Game::OnTouchImmuneTime)
	{
		return;
	}
	if (%obj.numEvents <= 0)
	{
		return;
	}
	%image = %player.getMountedImage (0);
	if (%image)
	{
		if (%image.getId () == AdminWandImage.getId ())
		{
			return;
		}
	}
	%client = %player.client;
	$InputTarget_["Self"] = %obj;
	$InputTarget_["Player"] = %player;
	$InputTarget_["Client"] = %client;
	if ($Server::LAN)
	{
		$InputTarget_["MiniGame"] = getMiniGameFromObject (%client);
	}
	else if (getMiniGameFromObject (%obj) == getMiniGameFromObject (%client))
	{
		$InputTarget_["MiniGame"] = getMiniGameFromObject (%obj);
	}
	else 
	{
		$InputTarget_["MiniGame"] = 0;
	}
	%isVehicle = 0;
	$InputTarget_["Driver"] = 0;
	if (!isObject (%client))
	{
		%isVehicle = 1;
		$InputTarget_["Bot"] = %player;
		if (isObject (%player.getMountedObject (0)))
		{
			$InputTarget_["Driver"] = %player.getMountedObject (0);
		}
		if (%obj.getGroup ().blid != 888888)
		{
			if ($Server::LAN)
			{
				if (isObject (%player.spawnBrick))
				{
					%client = %player.spawnBrick.client;
				}
				if (!isObject (%client))
				{
					%client = %player.getControllingClient ();
				}
				if (!isObject (%client))
				{
					%client = ClientGroup.getObject (0);
				}
			}
			else 
			{
				if (isObject (%player.spawnBrick))
				{
					%client = findClientByBL_ID (%player.spawnBrick.getGroup ().bl_id);
				}
				if (!isObject (%client))
				{
					%client = %player.lastControllingClient;
				}
			}
		}
	}
	if (isObject (%client) || %obj.getGroup ().bl_id == 888888)
	{
		if (%isVehicle)
		{
			%obj.processInputEvent ("OnBotTouch", %client);
		}
		else 
		{
			%obj.processInputEvent ("OnPlayerTouch", %client);
		}
	}
}

//lets bots be able to damage players with projectiles
function ProjectileData::onCollision (%this, %obj, %col, %fade, %pos, %normal, %velocity)
{
	%client = %obj.client;
	if (isObject (%obj.sourceObject) && %obj.sourceObject.isBot)
	{
		%client = %obj.sourceObject;
	}
	%victimClient = %col.client;
	%clientBLID = getBL_IDFromObject (%obj);
	if (isObject (%client.miniGame))
	{
		if (getSimTime () - %client.lastF8Time < 3000)
		{
			return;
		}
	}
	%scale = getWord (%obj.getScale (), 2);
	%mask = $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType;
	if (%col.getType () & %mask)
	{
		if (!isObject (%client))
		{
			return;
		}
		%yourStuffOverride = 0;
		if (!isObject (%client.miniGame))
		{
			if (isObject (%col.spawnBrick))
			{
				if (%col.spawnBrick.getGroup ().bl_id == %clientBLID || %col.spawnBrick.getGroup ().bl_id == 888888)
				{
					%yourStuffOverride = 1;
				}
			}
		}
		if (miniGameCanDamage (%client, %col) == 1 || %yourStuffOverride)
		{
			%this.Damage (%obj, %col, %fade, %pos, %normal);
			%this.impactImpulse (%obj, %col, %velocity);
		}
	}
	else if (%col.getType () & $TypeMasks::FxBrickObjectType)
	{
		%mg = %client.miniGame;
		if (isObject (%mg))
		{
			%respawnTime = %mg.BrickRespawnTime;
		}
		else 
		{
			%respawnTime = mClampF ($Server::BrickRespawnTime, 1000, 60000);
		}
		%blowUp = 0;
		%brickExplosionMaxVolume = %this.brickExplosionMaxVolume * %scale;
		%brickExplosionMaxVolumeFloating = %this.brickExplosionMaxVolumeFloating * %scale;
		if (%this.brickExplosionImpact == 1)
		{
			%blowUp = 1;
			if (!%col.canExplode (%brickExplosionMaxVolume, %brickExplosionMaxVolumeFloating))
			{
				%blowUp = 0;
			}
			if ($Server::LAN)
			{
				if (isObject (%mg))
				{
					if (!%mg.BrickDamage)
					{
						%blowUp = 0;
					}
				}
			}
			else if (isObject (%mg))
			{
				if (miniGameCanDamage (%client, %col) != 1)
				{
					%blowUp = 0;
				}
			}
			else if (isObject (%obj.sourceObject))
			{
				if (%col.getGroup ().bl_id != %clientBLID && %col.getGroup () != %obj.sourceObject.getGroup ())
				{
					%blowUp = 0;
				}
			}
			else if (%col.getGroup ().bl_id != %clientBLID)
			{
				%blowUp = 0;
			}
			if (%blowUp)
			{
				%col.onBlownUp (%client, %obj.sourceObject);
				transmitBrickExplosion (%pos, %this.brickExplosionForce, 0.02, %respawnTime, %col);
			}
		}
		if (!%blowUp)
		{
			%col.onProjectileHit (%obj, %client);
		}
	}
}

//and code for bots to not be able to bypass trust in singleplayer
function getTrustLevel (%obj1, %obj2)
{
	// if ($Server::LAN)  //just had to comment this out
	// {
	// 	return $TrustLevel::You;
	// }
	if (!isObject (%obj1))
	{
		error ("ERROR: getBL_IDfromObject() - \"" @ %obj1 @ "\" (%obj1) is not an object");
		return 0;
	}
	if (!isObject (%obj2))
	{
		error ("ERROR: getBL_IDfromObject() - \"" @ %obj2 @ "\" (%obj2) is not an object");
		return 0;
	}
	%brickGroup1 = getBrickGroupFromObject (%obj1);
	%bl_id1 = %brickGroup1.bl_id;
	%brickGroup2 = getBrickGroupFromObject (%obj2);
	%bl_id2 = %brickGroup2.bl_id;
	if (%bl_id1 == %bl_id2)
	{
		return $TrustLevel::You;
	}
	if (%brickGroup1.isPublicDomain || %brickGroup2.isPublicDomain)
	{
		return $TrustLevel::Full;
	}
	if (%brickGroup1.Trust[%bl_id2] != %brickGroup2.Trust[%bl_id1])
	{
		$lastError = $LastError::Trust;
		error ("ERROR: getTrustLevel() - trust levels between " @ %bl_id1 @ " and " @ %bl_id2 @ " are assymetrical.");
		return $TrustLevel::None;
	}
	else 
	{
		$lastError = $LastError::Trust;
		return %brickGroup1.Trust[%bl_id2];
	}
}
